Subject: Re: Clone hangs when done over http with --reference

From: Konstantin Ryabitsev <[email-masked]>
Date: Thu, 14 May 2015 13:08:46 -0400

On 13/05/15 08:47 PM, Jeff King wrote:
> I don't know if there's a way to convince Apache to be more interactive.
> As a hacky workaround, we could basically spool all of the input into
> memory (or a tempfile) and work from that. Or the output. Either way
> would break the pipe deadlock. But we'd have to be sensitive to the type
> of request (it's probably OK to spool ref negotiation, but not OK to
> spool packfiles, which can be arbitrarily big).

Thanks for looking into this, Jeff.

Two questions:

1. Does this mean there are potential problems with other git operations
that involve ref negotiation, not just when doing git clone --reference?
Is there a chance to run in to this deadlock by doing an operation like
"git remote update"?

2. If we configure the webserver to serve some files directly, without
passing them to http-backend, e.g. doing the recommended apache magic:

> AliasMatch ^/git/(.*/objects/[0-9a-f]{2}/[0-9a-f]{38})$          /var/lib/git/$1
> AliasMatch ^/git/(.*/objects/pack/pack-[0-9a-f]{40}.(pack|idx))$ /var/lib/git/$1
> AliasMatch ^/git/(.*/refs/heads/.*)$                             /var/lib/git/$1

Will that make the spooling less of a problem, since it won't involve
the super-huge files?

Best,
-Konstantin